#ifndef _COM_H
#define _COM_H

#define	ADAPTER_ID             "rs485com"	
#define ADDRESS_REGION_SIZE    8

#define TXENABLE    UART_MCR_OUT2|UART_MCR_DTR
#define RXENABLE    UART_MCR_RTS|UART_MCR_DTR|UART_MCR_OUT2
#define RX_TX_REG	UART_MCR
#define FIRST  (UART_LCR_SPAR|UART_LCR_PARITY|UART_LCR_WLEN8)
#define OTHER  (UART_LCR_SPAR|UART_LCR_EPAR|UART_LCR_PARITY|UART_LCR_WLEN8)

#define DIV_115	1
#define DIV_57	2
#define DIV_38	3
#define DIV_29	4
#define DIV_19	6

#define Fosc           1843
#define Minbaudrate      19
#define Maxbaudrate     115

#define IO_WAIT     300  // usec
#define IO_TIMEOUT 3000  // usec


#define 	RBYTE_WAIT     5		//	microseconds, ozhidanie baita 
#define		TBYTE_WAIT     5		//	microseconds (usec)
#define		TBYTE_TIMEOUT  500		// 500	microseconds (usec)
#define		RBYTE_TIMEOUT  500		// 500	microseconds (usec)
#define         RESP_WAIT      100              //      microseconds (usec) ozhidanie otveta

// status of receiver
#define PASSIVE_DATA  	  (0x01)
#define SIGNAL_RECEIVED   (0x02)
#define SIGNAL_SENT       (0x04)
#define RECEIVING         (0x08)
#define DATA_READY        (0x10)

int rs485_get_port(int irq);
void receiv_data(RS485INFO * info);
#endif
