#ifndef LPT_H
#define LPT_H

#define		ADAPTER_ID			"rs485lpt"
#define		ADDRESS_REGION_SIZE	8

// registers
#define		EPP_STATUS	1
#define		EPP_CONTROL	2
#define		EPP_ADDR	3
#define		EPP_DATA	4

// status register bits
#define		EPP_TIMEOUT			0x01

#define		EPP_RESET			0x04
#define		EPP_INT_ENABLE		0x10
#define		ENABLE_BI_DIRECT	0x20


// Time
#define		EPP_WAIT			500	// microseconds
//#define		EPP_WAIT		1000	// microseconds
#define		RESP_WAIT			100		// microseconds, ozhidanie otveta
//#define		MAX_CYCLE_RESP_WAIT	1000
#define		RESP_TIMEOUT	100000L	// microseconds

// status of receiver
#define		ACTIVE_DATA	0
#define		PASSIVE_DATA	1

//VK
#define  CONV_VERS1 0
#define  CONV_VERS2 1

// debug
#define TXENABLE    UART_MCR_OUT2|UART_MCR_DTR
#define RXENABLE    UART_MCR_RTS|UART_MCR_DTR|UART_MCR_OUT2
#define RX_TX_REG   UART_MCR

// transmission speed
#define DIV_115		7
#define DIV_230		3
#define DIV_460		1
#define DIV_921		0
#define DIV_1840	-128

#define IO_WAIT			30		// usec
#define IO_TIMEOUT		300		// usec


#define SECT_ADDRESSBYTE 1
#define SECT_LENGTHBYTE  2
#define SECT_DATABYTES   3
#define SECT_REPLYBYTE   4
#define SECT_OUTBYTES    6
#define SECT_SIGNAL      5
#define SECT_BADATA      7




#include <asm/io.h>
#ifndef __PP_PC__
int rs485_get_port(int irq);
#endif
void receiv_data(RS485INFO * info);
#endif
