#ifndef MCUA_H
#define MCUA_H
#ifdef __KERNEL__
	#include    "config.h"
#endif
#include            "version.h"
#include            "rsignal.h"

#ifdef __KERNEL__

#include <linux/version.h>
#undef KERN_2_6
#undef KERN_2_6_18
#undef KERN_2_6_21
#if(LINUX_VERSION_CODE > KERNEL_VERSION(2,6,0))
#define KERN_2_6 1
#endif
#if(LINUX_VERSION_CODE > KERNEL_VERSION(2,6,17))
#define KERN_2_6_18 1
#endif
#if(LINUX_VERSION_CODE > KERNEL_VERSION(2,6,20))
#define KERN_2_6_21 1
#endif
#if(LINUX_VERSION_CODE > KERNEL_VERSION(2,6,23))
#define KERN_2_6_24 1
#endif
#if(LINUX_VERSION_CODE > KERNEL_VERSION(2,6,24))
#define KERN_2_6_25 1
#endif
#if(LINUX_VERSION_CODE > KERNEL_VERSION(2,6,26))
#define KERN_2_6_27 1
#endif
#if(LINUX_VERSION_CODE > KERNEL_VERSION(2,6,35))
#define KERN_2_6_36 1
#define init_MUTEX(LOCKNAME) sema_init(LOCKNAME,1)
#endif

#endif

// ioctl

#define RS_IOC_MAGIC			'j'
#define	RS_RESET			_IO(RS_IOC_MAGIC,0)
#define RS_BLNUMBER_RESET		_IO(RS_IOC_MAGIC,1)
#define	RS_GET_VERS			_IOR(RS_IOC_MAGIC,3,int)
#define RS_GET_DATAFIFO_SIZE		_IO(RS_IOC_MAGIC,5)
#define RS_SET_BAUDRATE			_IO(RS_IOC_MAGIC,6)
#define RS_GET_BAUDRATE			_IO(RS_IOC_MAGIC,7)
#define RS_FIFO_FLUSH			_IO(RS_IOC_MAGIC,8)
#define RS_IOC_MAXNR	8


/* status of receiver
#define PASSIVE_DATA  	  (0x01)
#define SIGNAL_RECEIVED   (0x02)
#define SIGNAL_SENT       (0x04)
#define RECEIVING         (0x08)
#define DATA_READY        (0x10)
*/

// status of device
#define EXIST_FL  	  (0x01)

#define	CACHE_MAXSIZE	  (0x40)	// if > CACHE_MAXSIZE => Signal
#define PACKET_MAX_LENGTH (0x20)
#ifdef __KERNEL__
	#include	<asm/atomic.h>
	#include	<linux/serial_reg.h>
	#include	<linux/sched.h>
#ifdef KERN_2_6_27
	#include        <linux/semaphore.h>
#else
	#include	<linux/sem.h>
#endif
	typedef struct timeval	rs485_time_t;

// lpt? :
        #define MAX_TASK_DEVICE         32
        typedef struct _TASK_DEVICE_ {
            unsigned short    number;
            int               round_count_prev;
        } TASK_DEVICE;

#endif

#include "success.h"

#define         SEM_WAIT                100             //      microseconds (usec) zaderzhka pered otkrytiem semafora  
/*
#define 	RBYTE_WAIT		5		//	microseconds, ozhidanie baita 
#define		TBYTE_WAIT		5		//	microseconds (usec)
#define		TBYTE_TIMEOUT		500		// 500	microseconds (usec)
#define		RBYTE_TIMEOUT		500		// 500	microseconds (usec)
#define         RESP_WAIT               100             //      microseconds (usec) ozhidanie otveta
*/
#ifdef __KERNEL__
	#define MASK_CNT_PACKET     0x60
	#define MASK_ADR_PACKET     0X1F

	#define S_DATA_NAK		(0x8)
	#define S_FIFO_OVERFLOW		(0x40)

struct _OUT_BUFFER_ {
    unsigned char	cache[CACHE_MAXSIZE+1];
    size_t		size;	
};

struct _IN_BUFFER_ {
    unsigned char       cache[CACHE_MAXSIZE+1];
    size_t              size;
    unsigned char       adr;
    unsigned char       signature;
    
};

typedef struct _RS485_FIFO_ {
	unsigned char 		data_fifo[SIZE_STREAM_FIFO];
	volatile size_t 	data_wp;
	volatile size_t 	data_rp;
	atomic_t 	data_filled;	// skol'ko neschitannogo lezhit
	int 		nonblock;
#ifdef DECLARE_WAITQUEUE
	wait_queue_head_t	rs485_queue;
#else
	struct wait_queue	*rs485_queue;
#endif
} RS485FIFO;

struct RS {
    size_t                    usCountByteOut;
    size_t                    usCountByteInp; 
    volatile unsigned int     status;  // Current Status of receiver flags
    struct _IN_BUFFER_        inbuffer_pas;
    struct _OUT_BUFFER_       outbuffer;

    TASK_DEVICE                device[MAX_TASK_DEVICE];
    struct _IN_BUFFER_         inbuffer_act;        
    unsigned char              signal;
    RS485FIFO                  fifo;
#ifdef __LPT__
    int                        interface_type;
    int                        lSection;
    unsigned char              tmp_byte;
#endif
};


typedef struct _RS485INFO_ {
#ifdef __PP_PC__
    struct pardevice *pdev;
#endif
    unsigned short    base;
    int irq;

    int               baudrate;
    unsigned int      use_mcua;
    struct semaphore  sem;
    unsigned int      flags; // status of device (exist etc)
    struct RS        *rs;

} RS485INFO;

#endif

#endif
