#ifndef RSIGNAL_H
#define RSIGNAL_H

#define SignalPKL   0x81    // Packet loss detected (LPT converter own signal)
#define SignalPBO   0x82    // Converter FIFO overflowed (LPT converter own signal)
#define SignalEER   0x83    // General exchange error (driver signal)
#define SignalDSC   0x84    // Module doesn't respond or timeout (driver signal)
#define SignalCOL   0x86    // Transmission error or packets collision (driver signal)
#define SignalUND   0x90    // Unexpected data in place of signal (added signal)

#define SignalACK   0x87    // Successful data transmission (Line signal)
#define SignalNAK   0x96    // Broken packet was received (Line signal)
#define SignalNOD   0xA5    // Required data are not ready (Line signal)
#define SignalACN   0xB4    // This command does not exist (Line signal)
#define SignalACY   0xC3    // Acknowledgement of existing command (Line signal)
#define SignalACW   0xD2    // Command can't be executed right now (Line signal)
#define SignalSINC  0xE1    // Synchronization signal (Line signal)
#define SignalDNG   0xF0    // Dangerous signal (Line signal)

#ifndef __KERNEL__
    const char* rs_getsignal(int code);
    const char* rs_getsignaltxt(int code);
#endif

#endif
