%define     kernelversion           %(uname -r)
%define     kernelrequired          %(uname -r | cut -d'-' -f 1)
%define     distroversion           %(%{__cat} /etc/*-release | %{__sed} -n '1p')
%define     distrocode              %(%{__cat} /etc/*-release | %{__sed} -n '1p' | cut -f -1 -d ' ')
%define     gccversion              %(%{__cc} --version | %{__sed} -n '1p')
%define     rs485version            4.0.1
%define     rs485release            1
%define     modext                  %(if [ `uname -r | cut -d. -f -2` = "2.6" ] ; then echo ".ko" ; else echo ".o" ; fi)
%define     kernel_26               %(if [ `uname -r | cut -d. -f -2` = "2.6" ] ; then echo "1" ; fi)

%{!?modulesdir: %define modulesdir  /lib/modules/%{kernelversion} }

Summary:        rs485 interface linux driver
Name:           rs485
Version:        %{rs485version}
Release:        %{distrocode}_%{kernelrequired}_%{rs485release}
Copyright:      GPL
Group:          System/Kernel
Source0:        %{name}-%{rs485version}.tar.gz
Source1:        config-moxa102
Source2:        config-moxa132
Source3:        config-lpt
Source4:        config-com
URL:            http://dragon.sai.msu.ru/mass
Vendor:         The MASS group
Packager:       Matwey V. Kornilov
Distribution:   %{distroversion}
BuildRoot:      %{_tmppath}/%{name}-root
ExclusiveOs:    linux
ExclusiveArch:  i386 i586 i686
Requires:       kernel = %{kernelrequired}
Provides:       rs485

%description
The RS485 driver modules for Linux kernel.

Build options:
--------
Kernel      : %{kernelversion}
GCC         : %{gccversion}
Target      : %{_target_platform}
Distribution: %{distroversion}

Authors:
--------
       * Andre Zaitsev
       * Olga Voziakova (ovoz@sai.msu.ru)

%package -n rs485-source
Release:    %{rs485release}
Group:      Development/Sources
Summary:    sources of rs485 driver, needed for compilation programs

%description -n rs485-source
Source files of the RS485 driver modules for Linux kernel.

Build options:
--------
Kernel      : %{kernelversion}
GCC         : %{gccversion}
Target      : %{_target_platform}
Distribution: %{distroversion}

%prep
%setup -a 0

%build
# build moxa102 module
# build moxa132 module
# build lpt module
# build com module
for CONFIG in %{S:1} %{S:2} %{S:3} %{S:4}
do
	%{__make} clean
	%{__cp} $CONFIG .config
	yes '' | %{__make} config
	%{__make}
done

%install
%makeinstall MODDIR=%{modulesdir}
%{__mkdir_p} $RPM_BUILD_ROOT/usr/src
%{__tar} -v -zxf %{S:0} -C $RPM_BUILD_ROOT/usr/src
%{__ln_s} %{name}-%{rs485version} $RPM_BUILD_ROOT/usr/src/%{name}
%if %kernel_26
%{__install} -D -v -c -m 644 modules/modprobe-rs485.conf $RPM_BUILD_ROOT/etc/modprobe.d/rs485
%else
%{__install} -D -v -c -m 644 modules/modules-rs485.conf $RPM_BUILD_ROOT/etc/modules.d/rs485
%endif

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%post
/sbin/depmod

%postun
/sbin/depmod


%files
%defattr(-,root,root)
%doc ChangeLog README
%attr(0644,root,root) %{modulesdir}/misc/rs485m102%{modext}
%attr(0644,root,root) %{modulesdir}/misc/rs485m132%{modext}
%attr(0644,root,root) %{modulesdir}/misc/rs485com%{modext}
%attr(0644,root,root) %{modulesdir}/misc/rs485lpt%{modext}
%attr(0755,root,root) /usr/sbin/rs485_preload
%attr(0755,root,root) /usr/sbin/rs485_postload
%attr(0755,root,root) /usr/sbin/rs485_postremove
%if %kernel_26
%attr(0644,root,root) /etc/modprobe.d/rs485
%else
%attr(0644,root,root) /etc/modules.d/rs485
%endif


%files -n rs485-source
%defattr(0644,root,root,0755)
/usr/src/rs485
/usr/src/rs485-%{version}/

%changelog
* Sun Feb 04 2007 - matwey.kornilov@gmail.com
- added modprobe config scripts
* Tue May 30 2006 - matwey.kornilov@gmail.com
- added init.d script and 'unload' scripts. OMG...
* Wed Dec 28 2005 - matwey.kornilov@gmail.com
- improvements for 2.6 kernal
* Tue Aug  2 2005 - matwey@land.ru
- some improvements
* Tue Jun 30 2005 - matwey@land.ru
- some improvements
* Tue Mar 29 2005 - matwey@land.ru
- fixed %defattr
- added %clean secton
- added ExclusiveOS == linux, ExclusiveArch == i386 i586 i686 tags
* Mon Mar 28 2005 - matwey@land.ru
- initial release
